unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls,StdCtrls,Dialogs;

type
  TColorEdit=class(TPanel)
  private
    pnC,pnR,pnG,pnB:TPanel;
    eR,eG,eB,eC:TEdit;

  public
    constructor Create(AOwner: TComponent);override;
    procedure SetCaption(str:String);
end;

type
  TRGBDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    ceR,ceG,ceB,ceC:TColorEdit;
  public
    rr,rg,rb,rc,gr,gg,gb,gc,br,bg,bb,bc:Extended;
  end;

var
  RGBDialog: TRGBDialog;

implementation



{$R *.DFM}

constructor TColorEdit.Create(AOwner: TComponent);
begin

 inherited Create(AOwner);

 Parent:=TWinControl(AOwner);

 BorderStyle:=bsNone;
 BevelInner:=bvNone;
 BevelOuter:=bvNone;
 Width:=260;
 Height:=22;

 Visible:=True;

 pnC:=TPanel.Create(Self);
 pnC.Parent:=Self;
 pnC.BorderStyle:=bsNone;
 pnC.BevelInner:=bvNone;
 pnC.BevelOuter:=bvNone;
 pnC.Width:=24;
 pnC.Height:=20;
 pnC.Left:=1;
 pnC.Top:=1;
 pnC.Visible:=True;

 eR:=TEdit.Create(Self);
 eR.Parent:=Self;
 eR.Width:=36;
 eR.Height:=20;
 eR.Top:=1;
 eR.Left:=26;
 eR.Visible:=True;

 pnR:=TPanel.Create(Self);
 pnR.Parent:=Self;
 pnR.BorderStyle:=bsNone;
 pnR.BevelInner:=bvNone;
 pnR.BevelOuter:=bvNone;
 pnR.Width:=24;
 pnR.Height:=20;
 pnR.Left:=65;
 pnR.Top:=1;
 pnR.Caption:='R+';
 pnR.Visible:=True;

 eG:=TEdit.Create(Self);
 eG.Parent:=Self;
 eG.Width:=36;
 eG.Height:=20;
 eG.Top:=1;
 eG.Left:=91;
 eG.Visible:=True;

 pnG:=TPanel.Create(Self);
 pnG.Parent:=Self;
 pnG.BorderStyle:=bsNone;
 pnG.BevelInner:=bvNone;
 pnG.BevelOuter:=bvNone;
 pnG.Width:=24;
 pnG.Height:=20;
 pnG.Left:=130;
 pnG.Top:=1;
 pnG.Caption:='G+';
 pnG.Visible:=True;

 eB:=TEdit.Create(Self);
 eB.Parent:=Self;
 eB.Width:=36;
 eB.Height:=20;
 eB.Top:=1;
 eB.Left:=156;
 eB.Visible:=True;

 pnB:=TPanel.Create(Self);
 pnB.Parent:=Self;
 pnB.BorderStyle:=bsNone;
 pnB.BevelInner:=bvNone;
 pnB.BevelOuter:=bvNone;
 pnB.Width:=24;
 pnB.Height:=20;
 pnB.Left:=195;
 pnB.Top:=1;
 pnB.Caption:='B+';
 pnB.Visible:=True;

 eC:=TEdit.Create(Self);
 eC.Parent:=Self;
 eC.Width:=36;
 eC.Height:=20;
 eC.Top:=1;
 eC.Left:=222;
 eC.Visible:=True;

end;

procedure TColorEdit.SetCaption(str:String);
begin

  pnC.Caption:=str;

end;

procedure TRGBDialog.FormCreate(Sender: TObject);
begin

  ceR:=TColorEdit.Create(Self);

  ceR.Top:=4;
  ceR.Left:=4;
  ceR.setCaption('R=');

  ceG:=TColorEdit.Create(Self);

  ceG.Top:=32;
  ceG.Left:=4;
  ceG.setCaption('G=');

  ceB:=TColorEdit.Create(Self);

  ceB.Top:=60;
  ceB.Left:=4;
  ceB.setCaption('B=');

end;

procedure TRGBDialog.Button1Click(Sender: TObject);
begin

  try

    rr:=StrToFloat(ceR.eR.Text);
    rg:=StrToFloat(ceR.eG.Text);
    rb:=StrToFloat(ceR.eB.Text);
    rc:=StrToFloat(ceR.eC.Text);

    gr:=StrToFloat(ceG.eR.Text);
    gg:=StrToFloat(ceG.eG.Text);
    gb:=StrToFloat(ceG.eB.Text);
    gc:=StrToFloat(ceG.eC.Text);

    br:=StrToFloat(ceB.eR.Text);
    bg:=StrToFloat(ceB.eG.Text);
    bb:=StrToFloat(ceB.eB.Text);
    bc:=StrToFloat(ceB.eC.Text);

  except
    ShowMessage('̌ẂAlœĂ');
    ModalResult:=mrCancel;
    exit;
  end;

  ModalResult:=mrOK;

end;

procedure TRGBDialog.Button2Click(Sender: TObject);
begin

  ModalResult:=mrCancel;

end;

end.
